# -*- coding: utf-8 -*-
"""
/***************************************************************************
 tlGenericTopicManager
 
 Support for Sys Topics

 ***************************************************************************/
"""

from PyQt4 import QtCore, QtGui, QtXml
from PyQt4.QtCore import *
from PyQt4.QtGui import *

import os, imp

from qgis.utils import qgsfunction, QgsExpression
from qgis.core import *

from TelemetryLayer.tltopicmanager import tlTopicManager, tlFeatureDialog
from TelemetryLayer.lib.tlsettings import tlSettings as Settings
from TelemetryLayer.lib.tllogging import tlLogging as Log

from ui_tlgenerictopicmanager import Ui_tlGenericTopicManager


class tlGenericTopicManager(tlTopicManager, Ui_tlGenericTopicManager):
    def __init__(self, broker, create=False):
        super(tlGenericTopicManager, self).__init__(broker, create)
        self._topics = []
        self._broker = broker
        self._create = create
        self._featureDialog = None


    def featureDialog(self, dialog, tLayer, feature):
        try:
            # Let the $SYS type in the super class handle this 
            return super(tlGenericTopicManager, self).featureDialog(dialog, tLayer, feature)
        except Exception as e:
            Log("featureDialog " + str(e))
            return None


    def getWidget(self):
        super(tlGenericTopicManager, self).setupUi()
        QObject.emit(self, QtCore.SIGNAL('topicManagerReady'), True, self)
        return self.Tabs.widget(0)

    def setLabelFormatter(self, layer):
        Log.debug("setFormatter")
        palyr = QgsPalLayerSettings()
        palyr.readFromLayer(layer)
        palyr.enabled = True
        palyr.placement = QgsPalLayerSettings.OverPoint
        palyr.quadOffset = QgsPalLayerSettings.QuadrantBelow
        palyr.yOffset = 0.01
        palyr.fieldName = '$format_label'
        palyr.writeToLayer(layer)

    def setLayerStyle(self, layer):
      #  if not self.path() in QgsApplication.svgPaths():
       #     QgsApplication.setDefaultSvgPaths(QgsApplication.svgPaths() + [self.path()])
        self.loadStyle(layer, os.path.join(self.path(), "rules.qml"))


    @staticmethod
    def register():
        Log.debug("Generic Register")

        path = os.path.join(os.path.dirname(__file__), 'qgsfuncs.py')
        imp.load_source('qgsfuncs', path)
        icons = os.path.join(os.path.dirname(__file__), 'icons')

        if not icons in QgsApplication.svgPaths():
            QgsApplication.setDefaultSvgPaths(QgsApplication.svgPaths() + [icons])

        # from qgsfuncs import format_label
        pass


    @staticmethod
    def unregister():
        if QgsExpression.isFunctionName("$format_label"):
            QgsExpression.unregisterFunction("$format_label")
